import numpy as np

def flatten_population(population):
    flattened_parameters = np.array(population).reshape(-1)  # Efficient flattening using NumPy
    return flattened_parameters

def unflatten_population(flattened_parameters, number_of_population, number_of_dimensions, number_of_parameters_per_dimension):
    population = flattened_parameters.reshape(number_of_population, number_of_dimensions, number_of_parameters_per_dimension)
    return population